Subject: Re: pmac_zilog debugging ...

From: Benjamin Herrenschmidt <[email-masked]>
Date: Mon, 17 Nov 2008 22:40:18 +1100

On Mon, 2008-11-17 at 02:21 -0800, Kevin Diggs wrote:
> Benjamin Herrenschmidt wrote:
> >  
> > 
> > That's definitely strange. I would expect the kernel to be able to get
> > interrupts fast enough to service a 1200 bauds serial port. Maybe
> > there's something else wrong, or an other driver causing undue interrupt
> > latencies.... 
> > 
> As far as I can see the system is NOT busy. I see no evidence of excessive
> interrupt loading. It does have an Adaptec 2940 u2w SCSI card, an ATI video card,
> and a USB/firewire card. The SCSI card has some disks on it. The other two cards
> are unused. I guess, in theory, something in my 2.6.27 kernel could be causing one
> of the two unused cards to throw spurious interrupts?
> 
> I still think the hardware is mis-behaving.

That's strange. Maybe one of the drivers is occasionally hogging
interrutps. Well, there may also be a bug in the code :-)

One thing you can try is to disable DMA in macserial (shouldn't be hard
to hack) and see if it degrades the same way.

> > Out of curiosity, check that IDE properly unmasks interrupts (hdparm
> > -u1 /dev/hda).
> > 
> This is an 8600. It is SCSI only (the onboard controller is the MESH).

Ah yes.
 
> >> So, I'm on board with this approach. Since I don't really know what I am
> >>doing, how do you recommend I proceed?
> > 
> > 
> > Google for a document called MacTech.pdf which contains various
> > documentations for bits of the ancestor of the IO chip in your machine,
> > along with a description of the DBDMA engine :-) Something else you can
> > do is to look at how it's properly used by other drivers such as bmac
> > and look at some of the darwin source code for reference on how the HW
> > works.
> > 
> where might one find older Darwin source?

Apple still has most of them back to 10.0 and even the recent ones still
have an SCC serial driver afaik.

Ben.

> > Cheers,
> > Ben.
> > 
> > _______________________________________________
> > 
> 
> _______________________________________________
> Linuxppc-dev mailing list
> [email-masked]
> https://ozlabs.org/mailman/listinfo/linuxppc-dev